## exF-3.py
# AE3M33UI - Artificial Intellignece course, FEE CTU in Prague
#
# Exercise F-3: Learning curve

import numpy as np

from sklearn import tree
from sklearn.utils import shuffle
from sklearn import cross_validation, linear_model, pipeline

from plotting import *
from model_evaluation import *
from mpg import *


## Load data and create training and testing data set
X,y = load_mpg_for_classification(['hp'])
X,y = shuffle(X,y)
Xtr, Xtst, ytr, ytst = cross_validation.train_test_split(X, y, test_size = 0.20)
 
## Create a classifier
model = tree.DecisionTreeClassifier(max_depth=1)

## Learning curve
# Construct the array of training set sizes we are interested in.
tr_sizes = np.arange(5, ytr.shape[0])

train_errors, test_errors = compute_learning_curve(
    model, tr_sizes, Xtr, ytr, Xtst, ytst)
    
plot_learning_curve(tr_sizes, train_errors, test_errors)
         